﻿B4J=true
Group=Default Group
ModulesStructureVersion=1
Type=StaticCode
Version=7.8
@EndOfDesignText@
'Static code module
Sub Process_Globals
	Private fx As JFX
	Private RegexStr As String = "^[A-Za-z][A-Za-z0-9_]*"
End Sub

'Set a shortcut key for this menu item
'Returns the menu item
Public Sub SetShortCutKey(MI As JavaObject,Combination() As String) As MenuItem
	Dim KC As JavaObject
	KC.InitializeStatic("javafx.scene.input.KeyCombination")
	Dim KCS As String
	For i = 0 To Combination.Length - 1
		If i > 0 Then KCS = KCS & "+"
		KCS = KCS & Combination(i)
	Next
	MI.RunMethod("setAccelerator",Array(KC.RunMethod("keyCombination",Array(KCS))))
	Return MI
End Sub

Public Sub ValidVarName(Text As String) As Boolean
	If Text = "" Or Regex.IsMatch(RegexStr,Text) Then
		Return True
	End If
	Return False
End Sub

Public Sub ValidModName(Text As String) As Boolean
	If Text = "" Or Regex.IsMatch(RegexStr,Text) Then
		Return True
	End If
	Return False
End Sub

Public Sub SetTooltipTextSize(N As JavaObject, Size As Double)
	Try
		Dim F As Font = fx.DefaultFont(13)
		Dim Tooltip As JavaObject = N.RunMethod("getTooltip",Null)
		Tooltip.RunMethod("setFont",Array(F))
	Catch
		Log(LastException)
	End Try
End Sub

Public Sub StringCount(StringToSearch As String,TargetStr As String,IgnoreCase As Boolean) As Int
	If IgnoreCase Then
		StringToSearch = StringToSearch.ToLowerCase
		TargetStr = TargetStr.ToLowerCase
	End If

	Return (StringToSearch.Length - StringToSearch.Replace(TargetStr,"").Length) / Max(TargetStr.Length,1)

End Sub

Public Sub GetParentStr(Child As String) As String
	Dim Parent As String
	If Child.Contains(",") Then
		Parent = Child.SubString2(0,Child.LastIndexOf(","))
	Else
		Return ""
	End If
	Return Parent
End Sub

Public Sub FindLastParent(L As List,Search As String) As Int
	Dim Target As String
	For i = L.Size - 1 To 0 Step - 1
		Target = L.Get(i)
		If Target.StartsWith(Search) Then Return StringCount(Search,",",True)
	Next
	Return -1
End Sub

Public Sub CreateB4xLib(FileName As String, CodeStr As String)
	
	File.Delete(FileName,"")
	Dim Manifest() As Byte = File.ReadBytes(File.DirAssets,"Manifest.Txt")
	
	Try
		Dim FOS As JavaObject
		FOS.InitializeNewInstance("java.io.FileOutputStream",Array(FileName))
		Dim ZipOut As JavaObject
		ZipOut.InitializeNewInstance("java.util.zip.ZipOutputStream",Array(FOS))
	
		Dim B() As Byte = CodeStr.GetBytes("UTF8")
		Dim BIS As InputStream
		BIS.InitializeFromBytesArray(B,0,B.Length)
		
		Dim ZE As JavaObject
		ZE.InitializeNewInstance("java.util.zip.ZipEntry",Array(Main.tfModName.Text & ".bas"))
		ZipOut.RunMethod("putNextEntry",Array(ZE))
	
		Dim Bytes(1024) As Byte
		Dim Length As Int = 1024
		Do While True
			Length = BIS.ReadBytes(Bytes,0,Length)
			If Length = -1 Then Exit
			ZipOut.RunMethod("write", Array(Bytes,0,Length))
		Loop
		BIS.Close
		ZipOut.RunMethod("flush",Null)
		ZipOut.RunMethod("closeEntry",Null)
	

		Dim BIS As InputStream
		BIS.InitializeFromBytesArray(Manifest,0,B.Length)

		Dim ZE As JavaObject
		ZE.InitializeNewInstance("java.util.zip.ZipEntry",Array("Manifest.txt"))
		ZipOut.RunMethod("putNextEntry",Array(ZE))
		
		Dim Bytes(1024) As Byte
		Dim Length As Int = 1024
		Do While True
			Length = BIS.ReadBytes(Bytes,0,Length)
			If Length = -1 Then Exit
			ZipOut.RunMethod("write", Array(Bytes,0,Length))
		Loop
		BIS.Close
		ZipOut.RunMethod("flush",Null)
		ZipOut.RunMethod("closeEntry",Null)
		
		ZipOut.RunMethod("finish",Null)
		ZipOut.RunMethod("flush",Null)
		ZipOut.RunMethod("closeEntry",Null)
		ZipOut.RunMethod("close",Null)
		FOS.RunMethod("close",Null)
	Catch
		Log(LastException)
		Main.Dialog.Title = "File write Error"
		Wait For (Main.Dialog.Show($"Failed to create Zip file ${CRLF}Is the file open in your zip tool?"$,"OK","","")) Complete (Resp As Int)
		Return
	End Try
	
	Main.Dialog.Title = "Deploy Success"
	Wait For (Main.Dialog.Show($"Library  ${FileName} saved"$,"OK","","")) Complete (Resp As Int)
End Sub

Public Sub MenuSeparatorItem As JavaObject
	Dim TJO As JavaObject
	TJO.InitializeNewInstance("javafx.scene.control.SeparatorMenuItem",Null)
	Return TJO
End Sub

Public Sub ListToArray(L As JavaObject) As Object()
	Return L.RunMethod("toArray",Null)
End Sub