﻿B4J=true
Group=Default Group
ModulesStructureVersion=1
Type=Class
Version=7.8
@EndOfDesignText@
#Event: ItemClick(Index as Int, Value as Object)
Sub Class_Globals
	Private mEventName As String 'ignore
	Private mCallBack As Object 'ignore
	Private mBase As B4XView 'ignore
	Private xui As XUI 'ignore
	Public CustomListView1 As CustomListView
	Private XMLMap As Map
	Private TabSize As Int = 4
	Private mIndent As Boolean
	Private cbSelectionList As List
	Private cbSelectionAll As B4XView

	Type PaneDataType(DType As String, Name As String, Parents As List,Pane As B4XView, FriendlyName As String,NormalizedName As String ,Checked As Boolean, DSList As List)
	Type DataSaveType1(Key As String, DType As String, Name As String, FriendlyName As String, Values As List, Checked As Boolean, Merged As Boolean)
	Type DataSaveType(Key As String, DType As String, Name As String, FriendlyName As String, Text As String, Checked As Boolean, Merged As Boolean)
	
	
	Private ForbiddenVarNames As List
	Public DataOutputMap As Map
	Public DataCodeMap As Map
	Public NameMap As Map
	
	Public DataSaveKeyList As List
	Public DataSaveMap As Map
	
	Private PaneOutputMap As Map

	Public FriendlyNames As Map
	
	Public Merge As Boolean
	
	Public Dialog As B4XDialog

	Public lblInfo As B4XView
	
	
	Dim ContextMenu1 As ContextMenu
	
	Private MaxDispDataSize As Int = 20
	
	
End Sub

Public Sub Initialize (Callback As Object, EventName As String)
	mEventName = EventName
	mCallBack = Callback
	cbSelectionList.Initialize
	
	'Project DataLists
	FriendlyNames.Initialize
	
	
	'File DataList
	XMLMap.Initialize
	DataSaveKeyList.Initialize
	DataSaveMap.Initialize
	
	'Ouput Maps
	NameMap.Initialize
	PaneOutputMap.Initialize
	DataOutputMap.Initialize
	DataCodeMap.Initialize
	
	ForbiddenVarNames.Initialize
	ForbiddenVarNames.AddAll(Array As String("type","for","next","dim","end","if","while","loop"))
	
	CreateContextMenu
End Sub

Private Sub CreateContextMenu
	
	ContextMenu1.Initialize("CM")
	Dim Item As MenuItem
	Item.Initialize("Show Data","CM")
	ContextMenu1.MenuItems.Add(Item)
	Dim Item As MenuItem
	Item.Initialize("Show Data for selected items","CM")
	ContextMenu1.MenuItems.Add(Item)
	ContextMenu1.MenuItems.Add(MXML_Utils.MenuSeparatorItem)
	Dim Item As MenuItem
	Item.Initialize("Remove this Item","CM")
	ContextMenu1.MenuItems.Add(Item)
	Dim Item As MenuItem
	Item.Initialize("Remove all selected items","CM")
	ContextMenu1.MenuItems.Add(Item)
End Sub

Private Sub CM_Action
	Dim MI As MenuItem = Sender
	
	Select MI.Text
		Case "Remove this Item"
			Dim JO As JavaObject = MI
			JO = JO.RunMethod("getParentPopup",Null)
			DeleteItem(JO.RunMethod("getOwnerNode",Null))
			ClearXMLOutput
			PopulateCLV
		Case "Remove all selected items"
			If CBSelectedCount = 0 Then
				Dialog.Title = "Remove All selected Items"
				Wait For (Dialog.Show("No items selected","OK","","")) Complete (Resp As Int)
				Return
			End If
			For Each CB As CheckBox In cbSelectionList
				If CB.Checked Then
					DeleteItem(CB.Parent)
				End If
			Next
			ClearXMLOutput
			PopulateCLV
		Case "Show Data"
			Dim TV As B4XTable = Main.tvViewData
			Dim Lbl As Label = Main.lblViewData
			Lbl.Text = ""
			TV.Clear
			Dim JO As JavaObject = MI
			JO = JO.RunMethod("getParentPopup",Null)

			Dim P As B4XView = JO.RunMethod("getOwnerNode",Null)
			Dim PDT As PaneDataType = P.Tag

			Dim Columns(2) As B4XTableColumn
			Columns(0) = TV.AddColumn("No.",Main.tvViewData.COLUMN_TYPE_NUMBERS)
			Columns(0).Width = 50
			Columns(1) = TV.AddColumn(PDT.NormalizedName,Main.tvViewData.COLUMN_TYPE_TEXT)
			
			TV.MaximumRowsPerPage = 15
			TV.BuildLayoutsCache(15)
			
			For Each C As B4XTableColumn In Columns
				For i = 1 To C.CellsLayouts.Size - 1
					Dim Pnl As B4XView = C.CellsLayouts.Get(i)
					Pnl.GetView(0).SetTextAlignment("CENTER", "LEFT")
				Next
			Next
			
			Dim L As List
			L.Initialize
			For Each DS As DataSaveType1 In PDT.DSList
				For i = 0 To DS.Values.Size - 1
					Dim Arr(2) As String
					L.Add(Arr)
					Arr(0) = i + 1
					Arr(1) = DS.Values.Get(i)
				Next
			Next
			
			TV.SetData(L)
			
			Lbl.Text = DS.Values.Size & " Items listed from " & PDT.NormalizedName
			JO = Main.TabPane1.Tabs.Get(3)
			JO.RunMethod("setDisable",Array(False))
			Main.TabPane1.SelectedIndex = 3
			
		Case "Show Data for selected items"
			If CBSelectedCount = 0 Then
				Dialog.Title = "Show Data for selected items"
				Wait For (Dialog.Show("No items selected","OK","","")) Complete (Resp As Int)
				Return
			End If
			Dim TV As B4XTable = Main.tvViewData
			Dim Lbl As Label = Main.lblViewData
			
			TV.Clear
			
			Dim Cols As List
			Cols.Initialize
			Cols.Add("No.")
			
			Dim Rows As List
			Rows.Initialize
			
			'Collect Data
			
			Dim Data As List
			Data.Initialize
			
			Dim EntryCount As Int = 0
			For Each CB As CheckBox In cbSelectionList
				If CB.Checked Then
					Dim L As List
					L.Initialize
					Data.Add(L)
					Dim PDT As PaneDataType = CB.Parent.Tag
					Cols.Add(PDT.NormalizedName)
					For Each DS As DataSaveType1 In PDT.DSList
						For Each S As String In DS.Values
							L.Add(S)
						Next
					Next
					EntryCount = Max(EntryCount,L.Size)
				End If
			Next
			
	
			Dim Columns(Cols.Size) As B4XTableColumn
			
			For i = 0 To Cols.Size - 1
				Columns(i) = TV.AddColumn(Cols.Get(i),TV.COLUMN_TYPE_TEXT)
			Next
			Columns(0).Width = 50
			Columns(0).ColumnType = TV.COLUMN_TYPE_NUMBERS
			
			TV.MaximumRowsPerPage = 15
			TV.BuildLayoutsCache(15)
			
			For Each C As B4XTableColumn In Columns
				For i = 1 To C.CellsLayouts.Size - 1
					Dim Pnl As B4XView = C.CellsLayouts.Get(i)
					Pnl.GetView(0).SetTextAlignment("CENTER", "LEFT")
				Next
			Next
			
			For Each L As List In Data
				For i = L.Size To EntryCount - 1
					L.Add("")
				Next
			Next
			
			Dim RowNo As Int = 1
			Dim L As List
			For Entry = 0 To EntryCount - 1
				Dim Arr(Cols.Size) As String
				Arr(0) = Entry + 1
				Rows.Add(Arr)
				For RowNo = 0 To Data.Size - 1
					L = Data.Get(RowNo)
					Arr(RowNo + 1) = l.Get(Entry)
				Next
				RowNo = RowNo + 1
			Next
			
			TV.SetData(Rows)

			Dim JO As JavaObject
			JO = Main.TabPane1.Tabs.Get(3)
			JO.RunMethod("setDisable",Array(False))
			Main.TabPane1.SelectedIndex = 3
	End Select
	
End Sub

Private Sub DeleteItem(P As Pane)
	Dim PDT As PaneDataType = P.Tag
	For Each DS As DataSaveType1 In PDT.DSList
		DataSaveMap.Remove(DS.Key)
		Dim Pos As Int = DataSaveKeyList.IndexOf(DS.Key)
		If Pos > -1 Then DataSaveKeyList.RemoveAt(Pos)
	Next
End Sub

Public Sub ClearAllData
	ClearXMLData
	FriendlyNames.Clear
End Sub

Public Sub ClearXMLData
	'DataLists
	XMLMap.Clear
	DataSaveKeyList.Clear
	DataSaveMap.Clear
	'OutputLists
	ClearXMLOutput

End Sub

Public Sub ClearXMLOutput
	CustomListView1.Clear
	DataOutputMap.Clear
	PaneOutputMap.Clear
	NameMap.Clear
	cbSelectionList.Clear
End Sub

Public Sub ClearFields
	lblInfo.Text = ""
End Sub

'Base type must be Object
Public Sub DesignerCreateView (Base As Object, Lbl As Label, Props As Map)
	mBase = Base
	Sleep(0)
	mBase.LoadLayout("MineXML")
	Dialog.Initialize(mBase.Parent)
'  	Dim clr As Int = xui.PaintOrColorToColor(Props.Get("TextColor")) 'Example of getting a color value from Props
End Sub

Private Sub Base_Resize (Width As Double, Height As Double)
  
End Sub


Public Sub LoadXML(FileName As String, ShowProgress As Boolean)
	ClearXMLData
	
	Merge = False
	
	If ShowProgress Then Main.UpdateLblLoading("Parse 1")
	Sleep(50)
	
	Try
		Dim XML2M As Xml2Map
		XML2M.Initialize
		XMLMap = XML2M.Parse2(File.OpenInput(FileName,""))
	Catch
		Log(LastException)
		CallSubDelayed2(Main,"LoadXML_Complete",False)
		Return
	End Try
	
	
	If ShowProgress Then Main.UpdateLblLoading("Parse 2")
	Sleep(50)
	
	
	Dim L As List
	L.Initialize
	XMLMapToDataDo(XMLMap,L)
	
	
	If ShowProgress Then Main.UpdateLblLoading("Updating list")
	Sleep(50)
	
	PopulateCLV
	
	CallSubDelayed2(Main,"LoadXML_Complete",True)
		
End Sub

Public Sub MergeXML(FileName As String, ShowProgress As Boolean)
		
	Dim Count As Int = CustomListView1.Size

	lblInfo.Text = ""
	
	'Merge flag
	Merge = True
	
	If ShowProgress Then Main.UpdateLblLoading("Parse 1")
	Sleep(50)
	
	Try
		Dim XML2M As Xml2Map
		XML2M.Initialize
		XMLMap = XML2M.Parse2(File.OpenInput(FileName,""))
	Catch
		Log(LastException)
		CallSubDelayed2(Main,"MergeXML_Complete",False)
		Return
	End Try
	
	If ShowProgress Then Main.UpdateLblLoading("Parse 2")
	Sleep(50)
	
	'Run 2nd parse on the XMLMap data
	Dim L As List
	L.Initialize
	XMLMapToDataDo(XMLMap,L)
	
	If ShowProgress Then Main.UpdateLblLoading("Updating list")
	Sleep(50)
	
	'Update the gui
	ClearXMLOutput
	PopulateCLV
	UpdateInfoLabel($" ${CustomListView1.Size - Count} added "$)
	
	'Done
	CallSubDelayed2(Main,"MergeXML_Complete",True)
End Sub

Public Sub UpdateInfoLabel(Append As String)
	lblInfo.Text = $"${CustomListView1.Size} Items :  ${CBSelectedCount} Selected"$
End Sub

Public Sub RestoreSavedProject
	ClearXMLOutput
	UpdateInfoLabel("")
	PopulateCLV
	UpdateInfoLabel("")
End Sub


Private Sub XMLMapToDataDo(M As Map, TagList As List)
	
	For Each K As Object In M.Keys
		Dim JO As JavaObject = ""															'Ignore
		Dim Key As String = JO.RunMethod("join",Array(",",TagList))
		Key = Key & "," & K
		Dim FN As String = FriendlyNames.GetDefault(Key,"")
		If M.Get(K) Is Map Then
			Dim TL1 As List
			TL1.Initialize
			TL1.AddAll(TagList)
			If TL1.Size = 0 Or TL1.Get(TL1.Size - 1) <> K Then TL1.Add(K)
			XMLMapToDataDo(M.Get(K), TL1)
		Else If M.Get(K) Is List Then
			Dim L As List = M.Get(K)
			For Each O As Object In L
				If O Is Map Then
					Dim TL1 As List
					TL1.Initialize
					TL1.AddAll(TagList)
					If TL1.Size = 0 Or TL1.Get(TL1.Size - 1) <> K Then TL1.Add(K)
					XMLMapToDataDo(O, TL1)
				Else
					If DataSaveMap.ContainsKey(Key) = False Then
						Dim DS As DataSaveType1 = NewDataSaveType1(Key,"Str1",K,FN,O,False)
						DataSaveMap.Put(Key,DS)
						DataSaveKeyList.Add(Key)
					Else
						DS = DataSaveMap.Get(Key)
						DS.Values.Add(O)
					End If
				End If
			Next
		Else
			If DataSaveMap.ContainsKey(Key) = False Then
				Dim DS As DataSaveType1 = NewDataSaveType1(Key,"Str2",K,FN,M.Get(K),False)
				DataSaveMap.Put(Key,DS)
				DataSaveKeyList.Add(Key)
			Else
				DS = DataSaveMap.Get(Key)
				DS.Values.Add(M.Get(K))
			End If
		End If
	Next
	
End Sub

Sub NewDataSaveType1(Key As String, DType As String, Name As String, FriendlyName As String, Text As String, Checked As Boolean) As DataSaveType1
	Dim DS As DataSaveType1
	DS.Initialize
	DS.Values.Initialize
	DS.Key = Key
	DS.DType = DType
	DS.Name = Name
	DS.Checked = Checked
	DS.FriendlyName = FriendlyName
	DS.Values.Add(Text)
	DS.Merged = Merge
	Return DS
End Sub

Public Sub PopulateCLV
	Dim Pos,Pos1 As Int
	Dim Parent As String
	
	Dim ParentStr As String
	Dim Indent As Int
	
	For Each Key As String In DataSaveKeyList
		Dim DS As DataSaveType1 = DataSaveMap.Get(Key)
		Pos1 = DS.Key.LastIndexOf(",")
		Pos = DS.Key.LastIndexOf2(",",Pos1-1) + 1
		Parent = DS.Key.SubString2(Pos,Pos1)
		ParentStr = DS.Key.SubString2(0,Pos1)
		Indent = MXML_Utils.StringCount(ParentStr,",",False) * TabSize
		Dim Parents As List
		Parents.Initialize
		Parents.AddAll(Regex.Split(",",ParentStr))
		Dim P As B4XView
		If PaneOutputMap.ContainsKey(DS.Key) = False Then
			Dim Text As String
			If DS.Values.Size > MaxDispDataSize Then
				Text = DS.Values.Size & " data items found"
			Else
				Dim SB As StringBuilder
				SB.Initialize
				For Each S As String In DS.Values
					SB.Append(",")
					SB.Append(S)
				Next
				Text = SB.ToString.SubString(1)
			End If
			P = CreateItemPane( Indent / TabSize,Parent,DS.Name,IndentStr(Indent) & Text,DS.FriendlyName,DS.Checked)
			CustomListView1.Add(P,Parents)
			PaneOutputMap.Put(DS.Key,P)
			Dim PDT As PaneDataType = NewPaneDataType(P,Parents,DS)
			If DS.FriendlyName <> "" Then
				PDT.NormalizedName = DS.FriendlyName
			Else
				PDT.NormalizedName = PDT.Name
			End If
			DataOutputMap.Put(DS.Key,PDT)
			If DS.Merged Then P.Color = 0xFFB9E5EC
		Else
			'Capture merged data
			If Merge Then
				P = PaneOutputMap.Get(DS.Key)
				For Each S As String In DS.Values
					P.GetView(3).Text = P.GetView(3).Text & ", " & S
				Next
				Dim PDT As PaneDataType = DataOutputMap.Get(DS.Key)
				PDT.DSList.Add(DS)
			End If
		End If
		 
	Next
	UpdateInfoLabel("")
	UpdateCheckedState
	If Merge = False Then UpdateInfoLabel("")
	
End Sub


Public Sub CreateCode(b4xlib As Boolean,Alert As Boolean) As String
	Dim GlobalString, UpdateElements,AddlSubs As StringBuilder
	GlobalString.Initialize
	UpdateElements.Initialize
	AddlSubs.Initialize
	
	Dim EventString As String

	NameMap.Clear
	DataCodeMap.Clear
	
	Dim Str1Count, Str2Count As Int
	
	'Pre parse
	For Each Key As String In DataOutputMap.Keys
		Dim PDT As PaneDataType = DataOutputMap.Get(Key)
		If PDT.Checked = False Then Continue
		DataCodeMap.Put(Key,PDT)
		If PDT.DType = "Str1" Then Str1Count = Str1Count + 1
		If PDT.DType = "Str2" Then Str2Count = Str2Count + 1
	Next
	
	
	UpdateElements.Append($"	Select Key${CRLF}"$)
	
	Dim InitSub As String = "Public Sub Initialize(FileName As String)"
	GlobalString.Append($"Type XMLDataType(ID As String, Parents As List)${CRLF}"$)
	For Each Key As String In DataCodeMap.Keys
		Dim PDT As PaneDataType = DataCodeMap.Get(Key)
		Dim Name As String = GetName(PDT.Name)
		PDT.NormalizedName = Name
		If FriendlyNames.ContainsKey(Key) Then Name = FriendlyNames.Get(Key)
		
		GlobalString.Append($"${TAB}Public ${Name} As XMLDataType${CRLF}"$)
			
		UpdateElements.Append($"			Case "${Key}"
				'${Name}
				${Name}.ID = "${PDT.Name}"
				${Name}.Parents = Parents${CRLF}"$)

	Next
	
	If Alert Then
		GlobalString.Append($"	Private mCallback As Object
	Private mEventName As String"$)
		
		InitSub = $"Public Sub Initialize(Callback As Object, EventName As String, FileName As String)
	mCallBack = Callback
	mEventName = EventName"$
		
		EventString = "#Event: UnknownKey(Key As String)"
		
		UpdateElements.Append($"			Case Else
				If KnownKeys.IndexOf(Key) = -1 Then
					If SubExists(mCallBack,mEventName & "_UnknownKey") Then CallSubDelayed2(mCallBack,mEventName & "_UnknownKey",Key)
				End If
"$)
		AddlSubs.Append($"Private Sub KnownKeys As List
	Return Array As String("$)
		Dim L As List = Main.GetKnownKeys
		For i = 0 To L.Size - 1
			Dim S As String = L.Get(i)
			AddlSubs.Append($""${S}""$)
			If i < L.Size - 1 Then 
				AddlSubs.Append(", _")
				AddlSubs.Append(CRLF)
			End If
		Next
		AddlSubs.Append(")")
		AddlSubs.Append(CRLF)
		AddlSubs.Append("End Sub")
	
	End If
	
	UpdateElements.Append($"		End Select"$)
	
	Dim CodeText As String = File.ReadString(File.DirAssets,"Template.txt")
	
	If b4xlib = False Then
		Dim SearchString As String = "@EndOfDesignText@"
		Dim Pos As Int = CodeText.IndexOf(SearchString) + SearchString.Length
		CodeText = CodeText.SubString(Pos).Trim
	End If
	
	Return CodeText.Replace("'{Event}",EventString).Replace("'{Globals}",GlobalString.ToString).Replace("'{InitSub}",InitSub).Replace("'{UpdateElements}",UpdateElements.ToString).Replace("'{AddlSubs}",AddlSubs.ToString)
	
End Sub

Public Sub CreateTestCode As String
	If DataCodeMap.Size = 0 Then Return ""
	Dim SB,SB1 As StringBuilder
	SB.Initialize
	SB1.Initialize
	For Each Key As String In DataCodeMap.Keys
		Dim PDT As PaneDataType = DataCodeMap.Get(Key)
		Dim Name As String = PDT.NormalizedName
		If FriendlyNames.ContainsKey(Key) Then Name = FriendlyNames.Get(Key)
		
		SB.Append($"LblStr.Append(ShortTest("${Name}",MineXML1.${Name}))${CRLF}"$)
		SB1.Append($"'LblStr.Append(Test("${Name}",MineXML1.${Name}))${CRLF}"$)
	Next
	SB.Append(CRLF)
	SB.Append(SB1)
	Return SB.ToString
End Sub

Private Sub GetName(Name As String) As String
	Name = Name.Replace(":","_").Replace("-","_")
	If ForbiddenVarNames.IndexOf(Name.ToLowerCase) > -1 Then Name = Name & "1"
	Dim NameCount As Int = NameMap.GetDefault(Name,0)
	NameMap.Put(Name,NameCount + 1)
	If NameCount > 0 Then
		Name = Name & NameCount
	End If
	Return Name
End Sub



Private Sub NewPaneDataType(P As B4XView,Parents As List, DS As DataSaveType1) As PaneDataType
	Dim PDT As PaneDataType
	PDT.Initialize
	PDT.DSList.Initialize
	PDT.DType = DS.DType
	PDT.Name = DS.Name
	PDT.Pane = P
	PDT.Parents = Parents
	PDT.FriendlyName = DS.FriendlyName
	PDT.Checked = DS.Checked
	PDT.DSList.Add(DS)
	P.Tag = PDT
	Return PDT
End Sub

Private Sub IndentStr(Length As Int) As String
	If mIndent = False Then Return ""
	Dim StrB As StringBuilder
	StrB.Initialize
	For i = 0 To Length - 1
		StrB.Append(" ")
	Next
	Return StrB.ToString
End Sub

Private Sub CreateItemPane(Level As Int,Parent As String,Name As String, Text As String, FriendlyName As String, Checked As Boolean) As B4XView
	Dim P As B4XView = xui.CreatePanel("ItemPane")
	P.Height = 25
	P.LoadLayout("MineXMLItem")
	P.GetView(0).Text = Level
	P.GetView(1).Text = Parent
	P.GetView(2).Text = Name
	P.GetView(3).Text = Text
	P.GetView(4).Checked = Checked
	P.GetView(5).Text = FriendlyName
	P.GetView(5).Tag = ""
	Dim TF As TextField = P.GetView(5)
	TF.PromptText = "Friendly Name"
	cbSelectionList.Add(P.GetView(4))
	Return P
End Sub

Public Sub setIndent(Checked As Boolean)
	mIndent = Checked
End Sub

Sub ItemPane_MouseClicked(EventData As MouseEvent)
	If EventData.SecondaryButtonPressed Then
		Private JOCM As JavaObject = ContextMenu1
		Private JOED As JavaObject = EventData
		Private ScreenX As Double = JOED.RunMethod("getScreenX", Null)
		Private ScreenY As Double = JOED.RunMethod("getScreenY", Null)
		JOCM.RunMethod("show",Array(Sender,ScreenX,ScreenY))
	End If
End Sub

Sub CustomListView1_ItemClick (Index As Int, Value As Object)
	Dim L As List = Value
	Dim SB As StringBuilder
	SB.Initialize
	For Each S As String In L
		SB.Append(", " & S)
	Next
	
	If SubExists(mCallBack,mEventName & "_ItemClick") Then CallSubDelayed3(mCallBack,mEventName & "_ItemClick",Index,Value)
End Sub

'Manage the SelectionAll check box
Private Sub cbSelectionAll_Click
	Dim Count As Int
	For Each CB As B4XView In cbSelectionList
		CB.Checked = cbSelectionAll.Checked
		Dim PDT As PaneDataType = CB.Parent.Tag
		PDT.Checked = CB.Checked
		For Each DS As DataSaveType1 In PDT.DSList
			DS.Checked = CB.Checked
		Next
		If CB.Checked Then Count = Count + 1
	Next
	UpdateInfoLabel("")
'	If Count = 1 Then
'		lblModulesSelected.Text = Count & " Module selected"
'	Else
'		lblModulesSelected.Text = Count & " Modules selected"
'	End If
End Sub

Private Sub cbSelection_Click
	Dim CB As CheckBox = Sender
	Dim PDT As PaneDataType = CB.Parent.Tag
	PDT.Checked = CB.Checked
	For Each DS As DataSaveType1 In PDT.DSList
		DS.Checked = CB.Checked
	Next
	UpdateCheckedState
End Sub

Public Sub UpdateCheckedState
	Dim First As Boolean = True
	Dim Selected As Boolean
	Dim Found As Boolean = False
	Dim JO As JavaObject = cbSelectionAll
	Dim Count As Int
	For Each CB As CheckBox In cbSelectionList
		If CB.Checked Then Count = Count + 1
		If First Then
			Selected = CB.Checked
			First = False
		Else
			If Found = False And Selected <> CB.Checked Then
				JO.RunMethod("setIndeterminate",Array(True))
				Found = True
			End If
		End If
	Next
	If Not(Found) Then
		JO.RunMethod("setIndeterminate",Array(False))
		cbSelectionAll.Checked = Selected
	End If
	UpdateInfoLabel("")
'	If Count = 1 Then
'		lblModulesSelected.Text = Count & " Module selected"
'	Else
'		lblModulesSelected.Text = Count & " Modules selected"
'	End If
End Sub

Public Sub CBSelectedCount As Int
	Dim Count As Int
	For Each CB As CheckBox In cbSelectionList
		If CB.Checked Then Count  = Count + 1
	Next
	Return Count
End Sub


Public Sub GetElements (m As Map, key As String) As List
	Dim res As List
	If m.ContainsKey(key) = False Then
		res.Initialize
		Return res
	Else
		Dim value As Object = m.Get(key)
		If value Is List Then Return value
		res.Initialize
		res.Add(value)
		Return res
	End If
End Sub

Private Sub FriendlyName_TextChanged (Old As String, New As String)

	Dim TF As B4XView = Sender
	If MXML_Utils.ValidVarName(TF.Text) = False Then
		Dim TFN As TextField = TF
		Dim SelPos As Int = TFN.SelectionStart - 1
		TF.Text = Old
		TFN.SetSelection(SelPos,SelPos)
		Return
	End If
	Dim PDT As PaneDataType = TF.Parent.Tag
	Dim JO As JavaObject = ""															'Ignore
	Dim Key As String = JO.RunMethod("join",Array(",",PDT.Parents))
	Key = Key & ","  & PDT.Name
	If FriendlyNames.ContainsKey(TF.Text.ToLowerCase) And FriendlyNames.Get(TF.Text.ToLowerCase) <> Key Then
		TF.TextColor = xui.Color_Red
	Else
		TF.TextColor = xui.Color_Black
	End If
End Sub

Sub FriendlyName_FocusChanged (HasFocus As Boolean)
	
	If HasFocus Then
		If Sender = Null Then Return
		Dim TF As B4XView = Sender
		If TF.Tag = "" Then TF.Tag = TF.Text.ToLowerCase
	Else
		Dim TF As B4XView = Sender
		Dim PDT As PaneDataType = TF.Parent.Tag
		Dim JO As JavaObject = ""															'Ignore
		Dim Key As String = JO.RunMethod("join",Array(",",PDT.Parents))
		Key = Key & ","  & PDT.Name
		
		If TF.Text <> "" And FriendlyNames.ContainsKey(TF.Text.ToLowerCase) And FriendlyNames.Get(TF.Text.ToLowerCase) <> Key Then
			TF.RequestFocus
			Dialog.Title = "Duplicate Friendly Name"
			Wait For (Dialog.Show(TF.Text & " is allocated to a different field, please choose another","OK","","")) Complete (Resp As Int)
			Return
		End If
		
		If FriendlyNames.ContainsKey(TF.Tag) And FriendlyNames.Get(TF.Tag) = Key Then
			FriendlyNames.Remove(TF.Tag)
			FriendlyNames.Remove(Key)
			PDT.FriendlyName = ""
			PDT.NormalizedName = PDT.Name
		End If
		
		TF.Tag = ""
		If TF.Text <> "" Then
			FriendlyNames.Put(Key,TF.Text)
			FriendlyNames.Put(TF.Text.ToLowerCase,Key)
			PDT.FriendlyName = TF.Text
			PDT.NormalizedName = TF.Text
		End If
	End If
End Sub
